<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Teknisa\DF\Modules\Entrada\Services\Dfe18500DocumentosParaComposicaoDeCustosService;

use Zeedhi\Framework\DTO\Request;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use \Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class Dfe18500DocumentosParaComposicaoDeCustosController extends \Teknisa\DF\Controllers\TeknisaCrud {
    
    protected $documentosParaComposicaoDeCustosService;
    protected $entityManager; 
    protected $crudService;
    protected $parameterBag;
    
    public function __construct($crudService, $parameterBag, Dfe18500DocumentosParaComposicaoDeCustosService $documentosParaComposicaoDeCustosService, EntityManager $entityManager, $environment) {
        $this->documentosParaComposicaoDeCustosService =  $documentosParaComposicaoDeCustosService;
        $this->crudService = $crudService;
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
    }
    
    public function documentosComposicaoDeCustos(Request\Filter $request, Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        
        //$conditions[0] --> P_CDFORNECED e $conditions[1] --> P_TCDFORNECED
        if(empty($conditions[0]["value"])) {
            $conditions[1]["value"] = 'TD';
        } else {
            $conditions[1]["value"] = '';
        }
        
        //$conditions[2] --> P_DATAINI, $conditions[3] --> P_DATAFIN  e  $conditions[4] --> P_TDATA
        if(empty($conditions[2]["value"]) && empty($conditions[3]["value"])) {
            $conditions[4]["value"] = 'TD';
        } else {
            $conditions[4]["value"] = '';
        }

        //$conditions[5] --> P_IDSTATUS e $conditions[6] --> P_IDSTATUSNFE
        if($conditions[5]["value"] === 'E') {
            $conditions[6]["value"] = 'A';
            $conditions[5]["value"] = 'TD';
        } else if(empty($conditions[5]["value"])) {
            $conditions[5]["value"] = 'TD';
            $conditions[6]["value"] = 'TD';
        } else {
            $conditions[6]["value"] = 'TD';
        }
       
        $dataSourceName = 'documentos_composicao_de_custos';
        $dataSet = $this->crudService->getFilteredDataSet('documentos_composicao_de_custos', $conditions);
    
        $dataSet = new DataSet('documentos_composicao_de_custos', $dataSet->getRows());
        $response->setDataSets(array($dataSet));
    }
    
    public function produtoItemproduto(Request\Filter $request, Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        
        $dataSet = $this->documentosParaComposicaoDeCustosService->produtoItemproduto($conditions);
        $dataSet = new DataSet('documentos_composicao_de_custos', $dataSet);
        
        $response->setDataSets(array($dataSet));
    }

}